/*
 * VMPlatformGUI.java
 *
 * Created on September 1, 2000, 11:27 AM
 */

package project.manager;
import java.util.Vector;
import javax.swing.tree.*;
import java.util.Hashtable;
import javax.swing.tree.DefaultTreeSelectionModel;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeNode;
import javax.swing.tree.TreePath;
import java.rmi.RemoteException;
import java.util.Enumeration;
import java.net.URL;
import javax.swing.ImageIcon;
import fipaos.util.DIAGNOSTICS;
/**
 *
 * @author  alastair
 * @version 
 */
public class VMPlatformGUI extends javax.swing.JFrame {
	private final static String IMAGE_DIRECTORY = "images/";
	private final static String AGENT_GIF		= "Agent.gif";
	private final static String DF_GIF			= "df.gif";
	//for storing the name of the host that the agent wants to move to
	private int _openResult;
    private int _saveResult;
	private Vector _rows = new Vector();
  	private Vector _column_names = new Vector();
	private VMPlatformManager _manager;
	private DefaultMutableTreeNode _root = null;
	private javax.swing.JFileChooser _chooseSaveItem;
	private javax.swing.JFileChooser _chooseLoadFile;
	private Vector _nodes = new Vector();
    /** Creates new form VMPlatformGUI */
    public VMPlatformGUI() {
        initComponents ();
        pack ();
    }
	/** Creates new form VMPlatformGUI */
    public VMPlatformGUI( String profile_location, String file_name ) {
		_manager = new VMPlatformManager( profile_location, file_name );
		//set up the selection model for the tree 
		DefaultTreeSelectionModel selection_model = new DefaultTreeSelectionModel();
		// only one item selectable at any one time
		selection_model.setSelectionMode( DefaultTreeSelectionModel.SINGLE_TREE_SELECTION );
		populateTree();
		setColumnTitles();
		_rows = _manager.getCellData();
		initFileChoosers();
        initComponents ();
		// set the selection model
		jTree1.setSelectionModel( selection_model );
		jTree1.setCellRenderer( new VMTreeRenderer() );
        pack ();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        loadMenuItem = new javax.swing.JMenuItem();
        saveMenuItem = new javax.swing.JMenuItem();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        ViewAgents = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        panel1 = new java.awt.Panel();
        shutdownButton = new javax.swing.JButton();
        refreshButton = new javax.swing.JButton();
        StartAgents = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        startAgentButton = new javax.swing.JButton();
        addAgentButton = new javax.swing.JButton();
        removeAgentButton = new javax.swing.JButton();
        jPanel7 = new javax.swing.JPanel();
        jTable1 = new javax.swing.JTable();
        jMenuBar1.setName("File\n");
        jMenuBar1.setFont(new java.awt.Font ("Arial", 0, 11));
        
        jMenu1.setLabel("File");
          jMenu1.setFont(new java.awt.Font ("Arial", 0, 11));
          jMenu1.setText("Menu");
          jMenu1.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  jMenu1ActionPerformed(evt);
              }
          }
          );
          
          loadMenuItem.setLabel("Load");
            loadMenuItem.setName("Load");
            loadMenuItem.setFont(new java.awt.Font ("Arial", 0, 11));
            loadMenuItem.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    loadMenuItemActionPerformed(evt);
                }
            }
            );
            jMenu1.add(loadMenuItem);
            
          saveMenuItem.setLabel("Save");
            saveMenuItem.setName("Save");
            saveMenuItem.setFont(new java.awt.Font ("Arial", 0, 11));
            saveMenuItem.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    saveMenuItemActionPerformed(evt);
                }
            }
            );
            jMenu1.add(saveMenuItem);
            jMenuBar1.add(jMenu1);
          setTitle("VM Manager");
        setFont(new java.awt.Font ("Arial", 0, 11));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        }
        );
        
        jTabbedPane1.setPreferredSize(new java.awt.Dimension(520, 200));
        jTabbedPane1.setBorder(new javax.swing.border.EtchedBorder());
        jTabbedPane1.setName("View Agents");
        jTabbedPane1.setFont(new java.awt.Font ("Arial", 0, 11));
        
        ViewAgents.setLayout(new java.awt.BorderLayout());
          ViewAgents.setBorder(new javax.swing.border.EtchedBorder());
          ViewAgents.setName("View Agents");
          ViewAgents.setFont(new java.awt.Font ("Times New Roman", 0, 11));
          
          jPanel2.setLayout(new java.awt.BorderLayout());
            jPanel2.setFont(new java.awt.Font ("Arial", 0, 11));
            
            jScrollPane1.setPreferredSize(new java.awt.Dimension(300, 100));
              jScrollPane1.setMinimumSize(new java.awt.Dimension(250, 75));
              jScrollPane1.setFont(new java.awt.Font ("Arial", 0, 11));
              
              jTree1.setBorder(new javax.swing.border.EtchedBorder());
                jTree1.setModel(new VMTreeModel( _root ));
                jTree1.setFont(new java.awt.Font ("Arial", 0, 11));
                jScrollPane1.setViewportView(jTree1);
                
                jPanel2.add(jScrollPane1, java.awt.BorderLayout.CENTER);
              
              
            panel1.setLayout(new java.awt.GridBagLayout());
              java.awt.GridBagConstraints gridBagConstraints1;
              panel1.setFont(new java.awt.Font ("Arial", 0, 11));
              panel1.setBackground(new java.awt.Color (204, 204, 204));
              panel1.setForeground(java.awt.Color.black);
              
              shutdownButton.setPreferredSize(new java.awt.Dimension(103, 25));
                shutdownButton.setToolTipText("Shutdown the selected Agent");
                shutdownButton.setMaximumSize(new java.awt.Dimension(103, 25));
                shutdownButton.setVerticalAlignment(javax.swing.SwingConstants.TOP);
                shutdownButton.setActionCommand("shutdownButton");
                shutdownButton.setFont(new java.awt.Font ("Arial", 0, 11));
                shutdownButton.setText("Shutdown");
                shutdownButton.setMinimumSize(new java.awt.Dimension(103, 25));
                shutdownButton.addActionListener(new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        shutdownButtonActionPerformed(evt);
                    }
                }
                );
                gridBagConstraints1 = new java.awt.GridBagConstraints();
                gridBagConstraints1.gridx = 0;
                gridBagConstraints1.gridy = 0;
                gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
                panel1.add(shutdownButton, gridBagConstraints1);
                
                
              refreshButton.setPreferredSize(new java.awt.Dimension(103, 25));
                refreshButton.setLabel("Refresh");
                refreshButton.setMaximumSize(new java.awt.Dimension(103, 25));
                refreshButton.setActionCommand("refreshButton");
                refreshButton.setFont(new java.awt.Font ("Arial", 0, 11));
                refreshButton.setMinimumSize(new java.awt.Dimension(103, 25));
                refreshButton.addActionListener(new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        jButton1ActionPerformed(evt);
                    }
                }
                );
                gridBagConstraints1 = new java.awt.GridBagConstraints();
                gridBagConstraints1.gridx = 0;
                panel1.add(refreshButton, gridBagConstraints1);
                
                jPanel2.add(panel1, java.awt.BorderLayout.EAST);
              
              ViewAgents.add(jPanel2, java.awt.BorderLayout.CENTER);
            
            jTabbedPane1.addTab("View Agents", ViewAgents);
          
          
        StartAgents.setLayout(new java.awt.BorderLayout());
          StartAgents.setFont(new java.awt.Font ("Arial", 0, 11));
          
          jPanel6.setLayout(new java.awt.GridBagLayout());
            java.awt.GridBagConstraints gridBagConstraints2;
            jPanel6.setFont(new java.awt.Font ("Arial", 0, 11));
            
            startAgentButton.setPreferredSize(new java.awt.Dimension(103, 25));
              startAgentButton.setLabel("Start Agent");
              startAgentButton.setMaximumSize(new java.awt.Dimension(117, 33));
              startAgentButton.setActionCommand("startAgent");
              startAgentButton.setFont(new java.awt.Font ("Arial", 0, 11));
              startAgentButton.setMinimumSize(new java.awt.Dimension(103, 25));
              startAgentButton.addActionListener(new java.awt.event.ActionListener() {
                  public void actionPerformed(java.awt.event.ActionEvent evt) {
                      startAgentButtonActionPerformed(evt);
                  }
              }
              );
              gridBagConstraints2 = new java.awt.GridBagConstraints();
              gridBagConstraints2.gridx = 0;
              jPanel6.add(startAgentButton, gridBagConstraints2);
              
              
            addAgentButton.setPreferredSize(new java.awt.Dimension(103, 25));
              addAgentButton.setLabel("Add Agent");
              addAgentButton.setMaximumSize(new java.awt.Dimension(103, 25));
              addAgentButton.setActionCommand("addAgent");
              addAgentButton.setFont(new java.awt.Font ("Arial", 0, 11));
              addAgentButton.setMinimumSize(new java.awt.Dimension(103, 25));
              addAgentButton.addActionListener(new java.awt.event.ActionListener() {
                  public void actionPerformed(java.awt.event.ActionEvent evt) {
                      addAgentButtonActionPerformed(evt);
                  }
              }
              );
              gridBagConstraints2 = new java.awt.GridBagConstraints();
              gridBagConstraints2.gridx = 0;
              jPanel6.add(addAgentButton, gridBagConstraints2);
              
              
            removeAgentButton.setLabel("Remove Agent");
              removeAgentButton.setActionCommand("removeAgent");
              removeAgentButton.setFont(new java.awt.Font ("Arial", 0, 11));
              removeAgentButton.addActionListener(new java.awt.event.ActionListener() {
                  public void actionPerformed(java.awt.event.ActionEvent evt) {
                      removeAgentButtonActionPerformed(evt);
                  }
              }
              );
              gridBagConstraints2 = new java.awt.GridBagConstraints();
              gridBagConstraints2.gridx = 0;
              jPanel6.add(removeAgentButton, gridBagConstraints2);
              
              StartAgents.add(jPanel6, java.awt.BorderLayout.EAST);
            
            
          jPanel7.setLayout(new java.awt.BorderLayout());
            jPanel7.setBorder(new javax.swing.border.EtchedBorder());
            jPanel7.setFont(new java.awt.Font ("Arial", 0, 11));
            
            jTable1.setModel(new VMTableModel( _rows, _column_names ));
              jTable1.setFont(new java.awt.Font ("Arial", 0, 11));
              jPanel7.add(jTable1, java.awt.BorderLayout.CENTER);
              
              StartAgents.add(jPanel7, java.awt.BorderLayout.CENTER);
            
            jTabbedPane1.addTab("Start Agent", StartAgents);
          
          
        getContentPane().add(jTabbedPane1, java.awt.BorderLayout.CENTER);
        
        setJMenuBar(jMenuBar1);
        
    }//GEN-END:initComponents

  private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
    populateTree();
	jTree1.setModel( new VMTreeModel( _root ) );
	jTree1.updateUI();
  }//GEN-LAST:event_jButton1ActionPerformed

  private void removeAgentButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeAgentButtonActionPerformed
	int i = jTable1.getSelectedRow();

	if( i > 0 )
	{
		_manager.removeAgent( i );
	}
	_rows = _manager.getCellData();
	//jTable1.setModel(new VMTableModel( _rows, _column_names ));
	jTable1.updateUI();
  }//GEN-LAST:event_removeAgentButtonActionPerformed

  private void addAgentButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addAgentButtonActionPerformed
	new AddAgent(this,true,_manager).show();
	jTable1.updateUI();
  }//GEN-LAST:event_addAgentButtonActionPerformed

  private void startAgentButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_startAgentButtonActionPerformed

	String class_name;
	String host;
    Object[] parameters = new Object[3];
    
    class_name = (String)jTable1.getValueAt( jTable1.getSelectedRow(), 0 );
    parameters[0] = (String)jTable1.getValueAt( jTable1.getSelectedRow(), 1 );
    parameters[1] = (String)jTable1.getValueAt( jTable1.getSelectedRow(), 2 );
    parameters[2] = (String)jTable1.getValueAt( jTable1.getSelectedRow(), 3 );
	host = (String)jTable1.getValueAt( jTable1.getSelectedRow(), 5 );
	//if its a remote host
    if( !host.equals( "platformVM" ) )
	{
    	_manager.startRemoteAgent( class_name, parameters, host );
	}
	else
	{
		//its local
		_manager.startLocalAgent( class_name, parameters);
	}
	// update the tree and the display 
	populateTree();
	jTree1.setModel( new VMTreeModel( _root ) );
	jTree1.updateUI();
		
  }//GEN-LAST:event_startAgentButtonActionPerformed

  private void shutdownButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_shutdownButtonActionPerformed
	int selected_rows[] = jTree1.getSelectionRows();
	int selected_row = selected_rows[0];
	TreePath tree_path = jTree1.getPathForRow( selected_row );
	int path_count = tree_path.getPathCount();
	
	DefaultMutableTreeNode node = (DefaultMutableTreeNode)tree_path.getLastPathComponent();
	String parent_string = null;
	DefaultMutableTreeNode parent = null;
	//if this is the root node the index will be out of bounds
	if( ( path_count - 2 )  >= 0 )
	{
		parent = (DefaultMutableTreeNode)tree_path.getPathComponent( path_count - 2 );
		parent_string = (String)parent.getUserObject();
	}
	String name = (String)node.getUserObject();
	//if this is the platform VM
	if( parent_string != null )
	{	
		_manager.shutdownAgent( name);
	}
	
	if( parent_string != null )
	{
		parent.remove( node );
	}
	populateTree();
	jTree1.setModel( new VMTreeModel( _root ) );
	jTree1.updateUI();
	
  }//GEN-LAST:event_shutdownButtonActionPerformed

  private void saveMenuItemActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveMenuItemActionPerformed
	try
	{
		_openResult = _chooseSaveItem.showSaveDialog(this);
		saveToFile(_chooseSaveItem.getCurrentDirectory(), _chooseSaveItem.getSelectedFile());
	}
	catch( NullPointerException e )
	{
	}
  }//GEN-LAST:event_saveMenuItemActionPerformed
	/**
	 * This method saves information from the GUI to a file.
	 * @param dirName java.io.File
	 * @param fileName java.io.File
	 */
	private void saveToFile(java.io.File dirName, java.io.File fileName)
	{
	}
	

  private void loadMenuItemActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadMenuItemActionPerformed
	
	
	_openResult = _chooseLoadFile.showOpenDialog(this);
	String dir = _chooseLoadFile.getCurrentDirectory().getAbsolutePath();
	String file = _chooseLoadFile.getSelectedFile().getName();
	if( dir != null && file != null )
	{
    	 _manager.initCellData( _chooseLoadFile.getCurrentDirectory().getAbsolutePath(), _chooseLoadFile.getSelectedFile().getName() );
	}
	
  }//GEN-LAST:event_loadMenuItemActionPerformed

  private void jMenu1ActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenu1ActionPerformed
// Add your handling code here:
  }//GEN-LAST:event_jMenu1ActionPerformed

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit (0);
    }//GEN-LAST:event_exitForm
	//set the titles of the columns for the VMTableModel
	private void setColumnTitles()
	{
		_column_names.add( "Class Name" );
		_column_names.add( "Profile Location" );
		_column_names.add( "Agent Name" );
		_column_names.add( "Ownership" );
		_column_names.add( "Start" );
		_column_names.add( "Host" );
  	}
	//error dialog
	private void showDialog( String message )
	{
		VMDialog dia = new VMDialog( this, true );
		dia.setMessage( message);
		dia.pack();
		dia.show();
	}
	//populate the VMTreeModel
	private void populateTree()
	{
		_root = new DefaultMutableTreeNode( "VM Manager" );
		constructVMmanagertNodes();
		constructRemoteNodes();
	}
	//construct the remote nodes so that they be displayed  
	private void constructRemoteNodes()
	{
		Hashtable agents_hosts = _manager.getHosts();
		Hashtable hosts = new Hashtable();
		Enumeration e = agents_hosts.elements();
		//the agents host hashtable is ( agent_name, [host,host_reference] )
		// duplicate host references need to be removed
		// this will be done automatically if it duplicate entries are put
		// into a hashtable
		Object[] arr = null;
		while( e.hasMoreElements() )
		{
			arr = (Object[])e.nextElement();
			hosts.put( arr[0], arr[1] );
		}
		//thses are the names of the agents
		Enumeration agents_keys = null;
		//these are the names of the hosts
		Enumeration keys = hosts.keys();
		String name = null;
		String agents_name = null;
		DefaultMutableTreeNode tree_node = null;
	
		while( keys.hasMoreElements() )
		{
			e = agents_hosts.elements();
			//get a host name
			name = (String)keys.nextElement();
			//get the list of agents that are running on this particular host
			agents_keys = agents_hosts.keys();
			
				//create a node for each host
			tree_node = new DefaultMutableTreeNode( name );
			_nodes.add( name );
			_root.add( tree_node );
			//find the agents attached to a particular host
			while( agents_keys.hasMoreElements() )
			{
				//get the name of the agent
				agents_name = (String)agents_keys.nextElement();
				//get the array with the host name and the vm reference
				arr = (Object[])agents_hosts.get( agents_name );
				//if the host name and for the node and the agent match add it to the correct host node
				if( ( (String)arr[0] ).equals( name ) )
				{
					//add the agents to the correct host node
					tree_node.add( new DefaultMutableTreeNode( agents_name ) );
				}
			}
		}
	}
	//construct the nodes for the agents running in the VM manager VM
	private void constructVMmanagertNodes()
	{
		DefaultMutableTreeNode node = null;
		Vector agents = _manager.getAgentList();
		int no_of_agents = agents.size();
		Object name = null;
		Object[] instance = null;
		for( int i = 0; i < no_of_agents; i++ )
		{
			name = agents.get( i );
			
			_root.add( new DefaultMutableTreeNode( name ) );
		}
	}
	/**
	 * Gets the ImageIcon with the given name
	 *
	 * @param image Name of the image to load
	 *
	 * @return The ImageIcon, or null if not found
	 */
	private ImageIcon getImageIcon( String image )
	{
		// Attempt to load image from filesystem
		ImageIcon i = null;
		
		URL url = ClassLoader.getSystemResource( IMAGE_DIRECTORY + image );
		
		if( url == null )
		{
			i = new ImageIcon( IMAGE_DIRECTORY + image );
		}
		else
		{
			i = new ImageIcon( url );
		}
		
		return i;
	}
    
    public void moveAgent( String agent_name, String host_port )
    {
        Vector row = null;
        
        int no_of_parameters = 3;

        for( int i = 0; i < _rows.size(); i++ )
        {
            row = (Vector)_rows.get(i);
            if( agent_name.equals( (String)row.get(2) ) )
            {
                //set up an object array with the correct number of elements
                Object[] parameters = new Object[no_of_parameters];
                //set up some variables
                String class_name = (String)row.get(0);
                //setup the parameters		      
                for( int n = 0 ; n < no_of_parameters; n++ )
                {
                  parameters[n] = (String)row.get( n + 1 );
                }
                //need to have some error checking here to ensure that the agent has
                //been shutdown before restarting
                _manager.shutdownAgent( agent_name );
                _manager.startRemoteAgent( class_name, parameters, host_port );
                break;
            }
        }
        populateTree();
        jTree1.setModel( new VMTreeModel( _root ) );
        jTree1.updateUI();
    }
    public String getSelected()
    {
        int selected_rows[] = jTree1.getSelectionRows();
        int selected_row = selected_rows[0];
        TreePath tree_path = jTree1.getPathForRow( selected_row );
        int path_count = tree_path.getPathCount();

        DefaultMutableTreeNode node = (DefaultMutableTreeNode)tree_path.getLastPathComponent();
        String parent_string = null;
        DefaultMutableTreeNode parent = null;
        //if this is the root node the index will be out of bounds
        if( ( path_count - 2 )  >= 0 )
        {
            parent = (DefaultMutableTreeNode)tree_path.getPathComponent( path_count - 2 );
            parent_string = (String)parent.getUserObject();
        }
        return (String)node.getUserObject();
    }
    
    public void moveAgent( String host )
    {
        int selected_rows[] = jTree1.getSelectionRows();
        int selected_row = selected_rows[0];
        TreePath tree_path = jTree1.getPathForRow( selected_row );
        int path_count = tree_path.getPathCount();

        DefaultMutableTreeNode node = (DefaultMutableTreeNode)tree_path.getLastPathComponent();
        String parent_string = null;
        DefaultMutableTreeNode parent = null;
        //if this is the root node the index will be out of bounds
        if( ( path_count - 2 )  >= 0 )
        {
            parent = (DefaultMutableTreeNode)tree_path.getPathComponent( path_count - 2 );
            parent_string = (String)parent.getUserObject();
        }
        String name = (String)node.getUserObject();
        Vector row = null;
        
        int no_of_parameters = 3;

        for( int i = 0; i < _rows.size(); i++ )
        {
            row = (Vector)_rows.get(i);
            if( name.equals( (String)row.get(2) ) )
            {
                //set up an object array with the correct number of elements
                Object[] parameters = new Object[no_of_parameters];
                //set up some variables
                String class_name = (String)row.get(0);
                //setup the parameters		      
                for( int n = 0 ; n < no_of_parameters; n++ )
                {
                  parameters[n] = (String)row.get( n + 1 );
                }
                //need to have some error checking here to ensure that the agent has
                //been shutdown before restarting
                _manager.shutdownAgent( name );
                _manager.startRemoteAgent( class_name, parameters, host );
                break;
            }
        }

        if( parent_string != null )
        {
            parent.remove( node );
        }
        populateTree();
        jTree1.setModel( new VMTreeModel( _root ) );
        jTree1.updateUI();
    }
	
    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
	DIAGNOSTICS.setMemoryLevel( DIAGNOSTICS.LEVEL_2 );
			
		if( args.length < 2)
		{
			System.out.println( "Usage: fipaos.platform.manager platform-profile-location loader-profile-name" );
		}
		else
		{
			new VMPlatformGUI (args[0], args[1] ).show ();
		}
        
    }
   
	
	/**
	 * Set the _chooseSaveItem property value.
	 * @return javax.swing.preview.JFileChooser
	 */
	
    public void initFileChoosers() 
	{
		try 
		{
			_chooseSaveItem = new javax.swing.JFileChooser();
			_chooseSaveItem.setName("chooseSaveItem");
			_chooseSaveItem.setBounds(5, 6, 500, 300);
			_chooseSaveItem.setFont (new java.awt.Font ("Arial", 0, 11));
			
			_chooseLoadFile = new javax.swing.JFileChooser();
			_chooseLoadFile.setName("chooseLoadFile");
			_chooseLoadFile.setBounds(5, 5, 500, 300);
			_chooseLoadFile.setFont (new java.awt.Font ("Arial", 0, 11));
		} 
		catch (java.lang.Throwable Exc) 
		{
		}
	}
	


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenuItem loadMenuItem;
    private javax.swing.JMenuItem saveMenuItem;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JPanel ViewAgents;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTree jTree1;
    private java.awt.Panel panel1;
    private javax.swing.JButton shutdownButton;
    private javax.swing.JButton refreshButton;
    private javax.swing.JPanel StartAgents;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JButton startAgentButton;
    private javax.swing.JButton addAgentButton;
    private javax.swing.JButton removeAgentButton;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables

	//inner class for rendering the tree
	class VMTreeRenderer extends javax.swing.tree.DefaultTreeCellRenderer
	{
		public VMTreeRenderer()
  		{
			super();
		}

    	public java.awt.Component getTreeCellRendererComponent( javax.swing.JTree tree, Object value, boolean sel, boolean expanded, boolean leaf, int row, boolean hasFocus )
   		{ 
			super.getTreeCellRendererComponent( tree, value, sel,expanded, leaf, row,hasFocus );
			if ( value == _root || _nodes.contains( (String)( (DefaultMutableTreeNode)value ).getUserObject()) )  
			{
				setIcon( getImageIcon( DF_GIF ) );
			}
			else
    		{
	      		setIcon( getImageIcon( AGENT_GIF ) );    			
	    	}
	    	return this;
		}
   	}
	//inner table model class
	private class VMTableModel extends javax.swing.table.DefaultTableModel 
	{
	  /** Creates new VMTableModel */
		public VMTableModel( Vector cell_data, Vector column_names) 
		{
		 	super( cell_data, column_names ); 
	  	}  
	}
	//inner tree model class
	private class VMTreeModel extends DefaultTreeModel {

		/** Creates new VMTreeModel */
		public VMTreeModel( TreeNode root) {
			super( root );


		}

	}

}