/*
 * VMManager.java
 *
 * Created on August 13, 2000, 9:00 AM
 */
 
package project.manager;
import fipaos.ont.fipa.fipaman.AgentID;
import fipaos.agent.FIPAOSAgent;
import fipaos.mts.InitialisationException;
import fipaos.mts.UnknownTargetException;
import fipaos.util.*;
import java.net.MalformedURLException;
import java.net.UnknownHostException;
import java.net.InetAddress;
import java.net.URL;
import java.rmi.*;
import java.rmi.activation.*;
import java.rmi.server.*;
import java.rmi.registry.*;
import java.util.Vector;
import java.util.Hashtable;
import java.io.*;
import java.util.Properties;
import java.lang.reflect.*;

/** 
 *
 * @author  alastair
 * @version 
 */
public class VMRemote extends Activatable implements  VMCommsInterface,java.io.Serializable {
	//stores the thread group that newly started agent belongs to
	private Vector _agent_threads = new Vector();
	// list of agents names
	private Vector _agent_list = new Vector();
	//hastable of agent names(key) and agent instances(object)
	private Hashtable _agents = new Hashtable();
    private String _security_policy = null;
    private String _code_base = null;
  /** Creates new VMManager */
	public VMRemote(ActivationID id, MarshalledObject data )throws RemoteException{
    /** Creates new RMICommsClient */
		super( id, 0 );
        //this will be used by the where are you task so that it can find out if its on the platformVM or a remote vm 
        System.setProperty( "vm", "remote" );
        _security_policy = System.getProperty( "java.security.policy" );
	    _code_base = System.getProperty( "java.rmi.server.codebase" );
        System.setSecurityManager( new RMISecurityManager() );
        Thread thread = Thread.currentThread();
        try
        {
            ClassLoader loader = RMIClassLoader.getClassLoader( _code_base );
            thread.setContextClassLoader( loader );
        }
        catch( Exception e )
        {
            e.printStackTrace();
        }
		
	
	}
  
    /** Create an agent which is constructed from the platform profile and the aid
     */
    public void createAgent(String name, Object[] parameters) throws RemoteException {
		startLocalAgent( name, parameters );
    }
	
    /** destroy the agent identified by the aid
     */
    public void destroyAgent(String name) throws RemoteException {
    }
	
    /** ask the agent to shut itself down
     */
    public void shutdownagent(String name) throws RemoteException {
		shutdownAgent( name );
    }
    
    /** Suspend the agent
     */
    public void suspend(String name) throws RemoteException {
    }
    /** allow the agent to resume after being suspended
     */
    public void resume(String name) throws RemoteException {
    }
	/** Adds the agent name to the list of agents and the hashtable of agent instances
   * @param agent_name the object representing the agent name
   * @param instance an object array with the class name in element 0 and the object representing the instance of the class
   */
  public synchronized void addToAgentList(Object agent_name,Object[] instance) {
    _agent_list.add( (String)agent_name );
    _agents.put( agent_name, instance );
  }
  
  /** REmove and agent from the agent list
   * @param agent_name an object representing the name of the agent
   */
  private synchronized void removeFromAgentLists(Object agent_name) {
    _agents.remove( agent_name );
    _agent_list.remove( (String)agent_name );
  }
		/** Starts a lovcsl agent
	   * @param class_name Name of the class to be instanitated
	   * @param parameters parameters to be passed to the constructor( at present 3 Strings)
	   * 
	   */
	  private void startLocalAgent(final String class_name,final Object[] parameters)
	  {
		
		// "started_agent" indicator
		final Object started_agent[] = { new Boolean( false ) };
		// A thread group so that the threads belonging to an agent can be kept track of
		ThreadGroup new_tg = new ThreadGroup( (String)parameters[1] );
		_agent_threads.add( new_tg );
		//inner class to create a thread for the agent to be started in
		Runnable r = new Runnable() 
		{
		  public void run()
		  {
			Object agent = null;
			try
			{
			  // get the class to instantiate
			  Class cl = Class.forName( class_name );
			  Class[] cl_arr = { String.class, String.class, String.class };
              
              
			  Constructor cons = cl.getDeclaredConstructor( cl_arr );
			  Object[] class_instance = new Object[2];
			  class_instance[0] = class_name;
			  class_instance[1] = cons.newInstance( parameters );
			  addToAgentList( (String)parameters[1], class_instance );

			  // Indicate that the Agent has started OK to the parent thread
			  synchronized( started_agent )
			  {
				started_agent[0] = new Boolean( true );
				started_agent.notify();
			  }
			}
			catch(Exception cnf)
			{
			  cnf.printStackTrace();
			}
		  }
		};

		try
		{
		  Thread thread = new Thread( new_tg, r );
		  thread.start();
		  // Wait for the thread to finish starting the Agent
		  synchronized( started_agent )
		  {
			while( !( (Boolean) started_agent[0] ).booleanValue() )
			{
			  try
			  {
				started_agent.wait();
			  }
			  catch( InterruptedException e )
			  {
			  }
			}
		  }
		}
		catch(Exception cnf)
		{
		  cnf.printStackTrace();
		}
	  }
	
	 /** Shut down the agent represented by the Object
   * @param agent The agent to be shutdown
   */
	private void shutdownAgent(Object agent) 
	{
		Object[] class_instance = null;
		class_instance = getAgentInstance( agent );
		FIPAOSAgent fipa_agent = (FIPAOSAgent)class_instance[1];
		fipa_agent.shutdown();
		removeFromAgentLists( agent );
	}
	
	  /** Get the object representing an instance of the an agent
   * @param agent_name name of the agent
   * @return an object array with the agent class in 0 and agent instance in 1
   */
	private synchronized Object[] getAgentInstance(Object agent_name) {
		return (Object[])_agents.get( agent_name );
	}
	
	
	public static void main( String[] args ){
	
	}
	
	
	
}
 